QwtSplineInterpolating(3)

NAME
QwtSplineInterpolating - Base class for a spline interpolation.

SYNOPSIS

#include <qwt_spline.h>

Inherits QwtSpline.

Inherited by QwtSplineG1.

  Public Member Functions
QwtSplineInterpolating ()
Constructor.
virtual ~QwtSplineInterpolating ()
Destructor.
virtual QPolygonF equidistantPolygon (const QPolygonF &, double distance, bool withNodes) const
Find an interpolated polygon with 'equidistant' points.
virtual QPolygonF polygon (const QPolygonF &, double tolerance) const override
Interpolate a curve by a polygon.
virtual QPainterPath painterPath (const QPolygonF &) const override
Interpolate a curve with Bezier curves.
virtual QVector< QLineF > bezierControlLines (const QPolygonF &) const =0
Interpolate a curve with Bezier curves.

  Additional Inherited Members

Detailed Description

Base class for a spline interpolation. Spline interpolation is the process of interpolating a set of points piecewise with polynomials. The initial set of points is preserved.

Definition at line 193 of file qwt_spline.h.

Member Function Documentation

  QVector< QLineF > QwtSplineInterpolating::bezierControlLines (const QPolygonF & points) const [pure virtual]

Interpolate a curve with Bezier curves. Interpolates a polygon piecewise with cubic Bezier curves and returns the 2 control points of each curve as QLineF.

Parameters
    points Control points

Returns
    Control points of the interpolating Bezier curves

Implemented in QwtSplineCubic, QwtSplinePleasing, QwtSplineLocal, QwtSplineC2, and QwtSplineC1.

  QPolygonF QwtSplineInterpolating::equidistantPolygon (const QPolygonF & points, double distance, bool withNodes) const [virtual]

Find an interpolated polygon with 'equidistant' points. When withNodes is disabled all points of the resulting polygon will be equidistant according to the parametrization.

When withNodes is enabled the resulting polygon will also include the control points and the interpolated points are always aligned to the control point before ( points[i] + i * distance ).

The implementation calculates bezier curves first and calculates the interpolated points in a second run.

Parameters
    points Control nodes of the spline
    distance Distance between 2 points according to the parametrization
    withNodes When true, also add the control nodes ( even if not being equidistant )

Returns
    Interpolating polygon

See also
    bezierControlLines()

Reimplemented in QwtSplineC2, and QwtSplineC1.

Definition at line 863 of file qwt_spline.cpp.

  QPainterPath QwtSplineInterpolating::painterPath (const QPolygonF & points) const [override], [virtual]

Interpolate a curve with Bezier curves. Interpolates a polygon piecewise with cubic Bezier curves and returns them as QPainterPath.

The implementation calculates the Bezier control lines first and converts them into painter path elements in an additional loop.

Parameters
    points Control points

Returns
    Painter path, that can be rendered by QPainter

Note
    Derived spline classes might overload painterPath() to avoid the extra loops for converting results into a QPainterPath

See also
    bezierControlLines()

Implements QwtSpline.

Reimplemented in QwtSplinePleasing, QwtSplineLocal, QwtSplineCubic, QwtSplineC2, and QwtSplineC1.

Definition at line 748 of file qwt_spline.cpp.

  QPolygonF QwtSplineInterpolating::polygon (const QPolygonF & points, double tolerance) const [override], [virtual]

Interpolate a curve by a polygon. Interpolates a polygon piecewise with Bezier curves approximating them by polygons.

The approximation is based on 'Piecewise Linear Approximation of Bézier Curves' by Roger Willcocks ( http://www.rops.org )

Parameters
    points Control points
    tolerance Maximum for the accepted error of the approximation

Returns
    polygon approximating the interpolating polynomials

See also
    bezierControlLines(), QwtSplineBezier::toPolygon()

Reimplemented from QwtSpline.

Definition at line 805 of file qwt_spline.cpp.

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.